package test

import java.net.URI
import org.springframework.http.HttpMethod
import org.springframework.http.client.ClientHttpRequestFactory
import org.springframework.web.client._

class RetryingRestTemplate(f: ClientHttpRequestFactory)
    extends RestTemplate(f) {

  override protected def doExecute[T](
      url: URI,
      method: HttpMethod,
      requestCallback: RequestCallback,
      responseExtractor: ResponseExtractor[T]): T = {
    defer {
      super.doExecute(url, method, requestCallback, responseExtractor)
    }
  }

  private def defer[T](thunk: => T): T = thunk
}
